> For the complete documentation index, see [llms.txt](https://docs.strongdm.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.strongdm.com/references/cli/admin/secretengines/create.md).

# sdm admin secretengines create

```shell
NAME:
   sdm admin secretengines create - create new secret engine

USAGE:
   sdm admin secretengines create command [command options] <secret engine type> <secret engine name> <secret store ID> <secret root path>

COMMANDS:
   active_directory  create a ActiveDirectoryEngine
   key_value         create a KeyValueEngine
   postgres          create a PostgresEngine
   sqlserver         create a SqlserverEngine
   mysql             create a MysqlEngine

OPTIONS:
   --json, -j       output as json
   --timeout value  set time limit for command
   --tags value     tags e.g. 'key=value,...'
   --help, -h       show help
```

### active\_directory

```shell
NAME:
   sdm admin secretengines create active_directory - create a ActiveDirectoryEngine

USAGE:
   sdm admin secretengines create active_directory [command options] [arguments...]

OPTIONS:
   --timeout value                      set time limit for command
   --after-read-ttl value               
   --binddn value                       (required)
   --bindpass value                     (required)
   --certificate value                  
   --connection-timeout value           (default: 0)
   --do-not-validate-timestamps         
   --insecure-tls                       
   --key-rotation-interval-days value   (default: 0)
   --max-backoff-duration value         
   --name value                         (required)
   --node-selector value                
   --password-length value              Password length (default: 0)
   --password-num-digits value          Numbers of digits to use when generating password (default: 0)
   --password-num-symbols value         Number of symbos to use when generating password (default: 0)
   --password-allow-repeat              If set to true allows for consecutive characters to repeat
   --password-exclude-characters value  Set of characters to exclude when generating password
   --password-exclude-uppercase         If set to true do not include upper case letters when generating password
   --request-timeout value              (default: 0)
   --secret-store-id value              (required)
   --secret-store-root-path value       (required)
   --start-tls                          
   --tags value                         tags e.g. 'key=value,...'
   --ttl value                          
   --upndomain value                    
   --url value                          (required)
   --userdn value                       
   --certificate-file value             path to file containing certificate
```

### key\_value

```shell
NAME:
   sdm admin secretengines create key_value - create a KeyValueEngine

USAGE:
   sdm admin secretengines create key_value [command options] [arguments...]

OPTIONS:
   --timeout value                     set time limit for command
   --key-rotation-interval-days value  (default: 0)
   --name value                        (required)
   --node-selector value               
   --secret-store-id value             (required)
   --secret-store-root-path value      (required)
   --tags value                        tags e.g. 'key=value,...'
```

### mysql

{% code overflow="wrap" %}

```sh
NAME:
   sdm admin secretengines create mysql - create a MysqlEngine

USAGE:
   sdm admin secretengines create mysql [command options] [arguments...]

OPTIONS:
   --timeout value                      set time limit for command
   --after-read-ttl value               
   --database value                     (required)
   --hostname value                     (required)
   --key-rotation-interval-days value   (default: 0)
   --name value                         (required)
   --node-selector value                
   --password value                     (required)
   --password-length value              Password length (default: 0)
   --password-num-digits value          Numbers of digits to use when generating password (default: 0)
   --password-num-symbols value         Number of symbos to use when generating password (default: 0)
   --password-allow-repeat              If set to true allows for consecutive characters to repeat
   --password-exclude-characters value  Set of characters to exclude when generating password
   --password-exclude-uppercase         If set to true do not include upper case letters when generating password
   --port value                         (required) (default: 0)
   --secret-store-id value              (required)
   --secret-store-root-path value       (required)
   --tags value                         tags e.g. 'key=value,...'
   --tls                                
   --tls-skip-verify                    
   --ttl value                          
   --username value                     (required)

```

{% endcode %}

### postgres

{% code overflow="wrap" %}

```sh
NAME:
   sdm admin secretengines create postgres - create a PostgresEngine

USAGE:
   sdm admin secretengines create postgres [command options] [arguments...]

OPTIONS:
   --timeout value                      set time limit for command
   --after-read-ttl value               
   --database value                     (required)
   --hostname value                     (required)
   --key-rotation-interval-days value   (default: 0)
   --name value                         (required)
   --node-selector value                
   --password value                     (required)
   --password-length value              Password length (default: 0)
   --password-num-digits value          Numbers of digits to use when generating password (default: 0)
   --password-num-symbols value         Number of symbos to use when generating password (default: 0)
   --password-allow-repeat              If set to true allows for consecutive characters to repeat
   --password-exclude-characters value  Set of characters to exclude when generating password
   --password-exclude-uppercase         If set to true do not include upper case letters when generating password
   --port value                         (required) (default: 0)
   --secret-store-id value              (required)
   --secret-store-root-path value       (required)
   --tags value                         tags e.g. 'key=value,...'
   --tls                                
   --ttl value                          
   --username value                     (required)

```

{% endcode %}

### sqlserver

{% code overflow="wrap" %}

```sh
NAME:
   sdm admin secretengines create sqlserver - create a SqlserverEngine

USAGE:
   sdm admin secretengines create sqlserver [command options] [arguments...]

OPTIONS:
   --timeout value                      set time limit for command
   --after-read-ttl value               
   --database value                     (required)
   --hostname value                     (required)
   --key-rotation-interval-days value   (default: 0)
   --name value                         (required)
   --node-selector value                
   --password value                     (required)
   --password-length value              Password length (default: 0)
   --password-num-digits value          Numbers of digits to use when generating password (default: 0)
   --password-num-symbols value         Number of symbos to use when generating password (default: 0)
   --password-allow-repeat              If set to true allows for consecutive characters to repeat
   --password-exclude-characters value  Set of characters to exclude when generating password
   --password-exclude-uppercase         If set to true do not include upper case letters when generating password
   --port value                         (required) (default: 0)
   --secret-store-id value              (required)
   --secret-store-root-path value       (required)
   --tags value                         tags e.g. 'key=value,...'
   --tls                                
   --tls-skip-verify                    
   --ttl value                          
   --username value                     (required)

```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.strongdm.com/references/cli/admin/secretengines/create.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
